AchSnd_Defaults = {
-- Default Settings   All settings can be changed in game with
-- the /achsnd command (command = variable name (case insensitive))
Guild = "on", -- Enable on guild member achievements
Party = "on", -- Enable on party members achievements
Near = "on",  -- Enable for people near you
--
-- Addon Output Settings
MSBT = "on",  -- Output achievement to Mik's Scrolling Battle Text
Popup = "on", -- Grats popup
Sound = "on", -- Enable Sound Output
Timeout = 15, -- Popup timeout between 0 - 60 secs
Random = "on", -- Random messages or default
DefaultMsg = "{star} Grats {star}", -- Default Grats Message
NewMsgBox = "on", -- Enables the new Achievement Alert frame
AutoFade = "on", -- Enables new alert frame to auto-fade when mouse not over it
MinAlpha = .35, -- Minimum alpha the frame will fade to
FadeDelay = 3, -- How long before frame fades to above alpha
--
-- Addon State
Enable = "on" -- enable/disable the addon 
}

AchSnd_DefaultsPC = {
AlertPosSet = 0 --Per char alert box pos saved
}


AchSnd_Settings = {}
AchSnd_SettingsPC = {}

AchSnd={}
AchSnd.Loaded = 0

AchSnd.Frame = CreateFrame("Frame")
AchSnd.Frame:RegisterEvent("ADDON_LOADED")
AchSnd.Frame:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
AchSnd.Frame:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")

local function addOptionMt(options, defaults)
	setmetatable(options, {__index = defaults})
	for i, v in pairs(options) do
		if type(v) == "table" and not getmetatable(v) then
			addOptionMt(v, defaults[i])
		end
	end
end

AchSnd.StatColor = function(stat)
	if (stat == "on") then
		return "|cFF00FF00[on]"
	elseif (stat == "off") then
		return "|cFFFF0000[off]"
	elseif (stat == 0) then
		return "|cFFFF0000[0] (DISABLED)"
	elseif ((stat > 0) and (stat <= 60)) then
		return string.format("|cFF00FF00[%i] second(s)", stat)
	end
	return stat
end

AchSnd.TextScanError  = function( text )
	for loop = 1, #text do
		if (string.byte( text, loop) > 127) then
			return true
		end
	end
	return false
end



StaticPopupDialogs["AchSnd.TextError"] = {
	text = "Message text cannot contain characters with an ASCII value greater than 127",
	button1 = "Okay",
	timeout = 20,
	showAlert = true
	}


AchSnd.RandMsg=function(mode)
--prefix and postfix must be in matching pairs
	local prefix = {"{star}{star}", "{circle}{circle}", "{diamond}{diamond}", "{triangle}{triangle}",	--prints raid icons
				"{moon}{moon}", "{square}{square}", "{x}{x}", "{skull}{skull}",							--to guild/party
				"{star}", "{circle}", "{diamond}", "{triangle}",										--chat only
				"{moon}", "{square}", "{x}", "{skull}",													--looks stupid in SAY

-- Above 16 not for SAY... put new non-say-able pair halves above this line	and increment sayoffset var
-- and say-able pair halves below this line 
				"..||..<(+_", "-o--{", "<(  0)>", "- - --^[", "( ' __ ' )",
				">--->", "<'))))><", ".||.<(+_+)>.||/.", "-<<ALERT>>-", "->]",
				"--<-@", "->>X<<-"
			}

	local postfix = {"{star}{star}", "{circle}{circle}", "{diamond}{diamond}", "{triangle}{triangle}",
				"{moon}{moon}", "{square}{square}", "{x}{x}", "{skull}{skull}",
				"{star}", "{circle}", "{diamond}", "{triangle}",
				"{moon}", "{square}", "{x}", "{skull}",
				
-- Above 16 not for SAY... put new non-say-able pair halves above this line	and increment sayoffset var
-- and say-able pair halves below this line 
				"_+)>..||..", "}--o-", "<(0  )>", "]^-- - -", "( ' __ ' )",
				"<---<", "><(((('>", ".||.<(+_+)>.||/.", "-<<ALERT>>-", "[<-",
				"@->--", "->>X<<-",
			}
	local grtz = {"Grats" , "Congratulations" , "Gratz" , "Grats on the Achievement" , "GrAtS" , "Congrats", "CoNgRaTs"}
	local sayoffset = 16
	local fixnum = 0
	if (mode == "SAY") then
		fixnum = math.random(1 + sayoffset, #prefix)
	else
		fixnum = math.random(1, #prefix)
	end
	return string.format("%s %s %s",prefix[fixnum],grtz[ math.random(1, #grtz)],postfix[fixnum])
end

AchSnd.Frame:SetScript("OnEvent",function(self, event,...)
	if (event == "ADDON_LOADED") then
		if (AchSnd.Loaded == 1) then
			return
		end
		print("\n\nAchievement Sounds loaded\n\n")
		addOptionMt( AchSnd_Settings , AchSnd_Defaults )
		addOptionMt( AchSnd_SettingsPC , AchSnd_DefaultsPC )
		AchSnd.Loaded = 1
		if ((AchSnd_SettingsPC.AlertPosSet == 0) and (AchSnd_Settings.NewMsgBox == "on")) then
			AchSnd.MsgFrame:Show()
		end
		
		return self, event, ...
	end
	
	if ( AchSnd_Settings.Enable == "off") then
		return
	end
	
	local args = {...}
	local color = {255,255,255}
	local mode = "DEFAULT"
	local msg = args[1]:format(args[5])
	
	if (args[5] == UnitName("player")) then
		return
	end
	
	if (event == "CHAT_MSG_ACHIEVEMENT")then
		if (UnitInParty(args[5])) then
			if (AchSnd_Settings.Party ~="on") then 
				return
			end
			color = {0,255,255}
			mode = "PARTY"
		else
			if (AchSnd_Settings.Near ~="on")then
				return
			end
			color = {255,255,255}
			mode = "SAY"
		end
	end
	
	if (event == "CHAT_MSG_GUILD_ACHIEVEMENT") then
		if (AchSnd_Settings.Guild ~= "on") then
			return
		end
		color = {0,255,0}
		mode = "GUILD"
	end
	
	if (mode == "DEFAULT") then
		return
	end

	if(IsAddOnLoaded("MikScrollingBattleText")) then
		if ((AchSnd_Settings.MSBT == "on") and (not(MikSBT.IsModDisabled() ))) then
			MikSBT.DisplayMessage( msg , MikSBT.DISPLAYTYPE_NOTIFICATION, true, color[1], color[2], color[3])
		end
	end

	if (AchSnd_Settings.Sound == "on") then
		PlaySound("LEVELUPSOUND")
	end
	
	if (AchSnd_Settings.Popup == "on") then
		if (AchSnd_Settings.NewMsgBox == "on") then
			AchSnd.MBox={text = msg, mode = mode}
			AchSnd.MsgFrame:Show()
		else
			StaticPopupDialogs["AchSnd.PopUp"] = {
			text = msg,
			button1 = mode.." Grats" ,
			button2 = "Cancel",
			OnAccept = function(self)
				if (AchSnd_Settings.Random == "on") then
					SendChatMessage( AchSnd.RandMsg(mode) , mode)
				else
					SendChatMessage( AchSnd_Settings.DefaultMsg , mode )
				end
			end,
			timeout = AchSnd_Settings.Timeout
			}	
			StaticPopup_Show("AchSnd.PopUp")
		end
	end
end)



SLASH_ACHSND1 = "/achsnd"
SLASH_ACHSND2 = "/achievementsounds"
SlashCmdList["ACHSND"] = function(msg)
	local cmd,arg = string.split(" ", msg)
	cmd = cmd:lower()
	local yel = "|cFFFFFF00"
	local wht = "|cFFFFFFFF"
	local blu = "|cFF00FFFF"
	local red = "|cFFFF0000"
	local grn = "|cFF00FF00"
	local res = "|r"

	if (cmd =="config") then
		InterfaceOptionsFrame_OpenToCategory( AchSnd.panel )
		return
	end
	
	if (cmd == "enable") then
		if ((arg == "off") or (arg == "on")) then
			AchSnd_Settings.Enable = arg
		end
		print(yel.."Achievement Sounds: Enable is "..AchSnd.StatColor(AchSnd_Settings.Enable)..res)
		if (AchSnd_Settings.Enable == "off") then
			print(yel.."Add On is "..red.."DISABLED"..res)
			print(yel.."Type: "..blu.."/achsnd enable on"..yel.." to turn add on back on")
		end
		return
	end
	
	if (AchSnd_Settings.Enable == "off") then
		print(" ")
		print(yel.."Achievement Sounds"..res)
		print(yel.."  This addon is "..red.."DISABLED"..res)
		print(yel.."  Type: "..blu.."/achsnd enable on"..res)
		print(yel.."  to enable."..res)
		return
	end
	
	if (cmd == "" ) then
		print(" ")
		print(yel.."________________________________________"..res)
		print(yel.."Achievement Sounds"..res)
		print(yel.."  Addon State:"..res)
		print(blu.."     Enable"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.Enable)..res)
		print(yel.."  Triggers:"..res)
		print(blu.."     Guild"..wht.." achievements are "..AchSnd.StatColor(AchSnd_Settings.Guild)..res)
		print(blu.."     Party"..wht.." achievements are "..AchSnd.StatColor(AchSnd_Settings.Party)..res)
		print(blu.."     Near"..wht.." achievements are "..AchSnd.StatColor(AchSnd_Settings.Near)..res)
		print(yel.."  Outputs:")
		print(blu.."     Sound"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.Sound)..res)
		print(blu.."     MSBT"..wht.." is  "..AchSnd.StatColor(AchSnd_Settings.MSBT)..res)
		print(blu.."     Popup"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.Popup)..res)
		print(blu.."     Timeout"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.Timeout)..res)
		print(blu.."     Random"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.Random)..res)
		print(blu.."     DefaultMsg"..wht.." is \" "..grn..AchSnd_Settings.DefaultMsg..wht.." \"" ..res)
		print(blu.."     NewMsgBox"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.NewMsgBox)..res)
		print(blu.."     MinAlpha"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.MinAlpha)..res)
		print(blu.."     FadeDelay"..wht.." is "..AchSnd.StatColor(AchSnd_Settings.FadeDelay)..res)
		print(yel.."Available commands are listed above in "..blu.."BLUE."..res)
		print(yel.."or type "..blu.."/achsnd config".. yel.." to open the GUI config screen."..res)
		print(yel.."________________________________________"..res)
		return
	end

	if (cmd == "guild") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.Guild = arg
		end
		print(yel.."Achievement Sounds: Guild is "..AchSnd.StatColor(AchSnd_Settings.Guild)..res)
		return
	end
	
	if (cmd == "party") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.Party = arg
		end
		print(yel.."Achievement Sounds: Party is "..AchSnd.StatColor(AchSnd_Settings.Party)..res)
		return
	end

	if (cmd == "near") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.Near = arg
		end
		print(yel.."Achievement Sounds: Near is "..AchSnd.StatColor(AchSnd_Settings.Near)..res)
		return
	end

	if (cmd == "sound") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.Sound = arg
		end
		print(yel.."Achievement Sounds: Sound is "..AchSnd.StatColor(AchSnd_Settings.Sound)..res)
		return
	end

	if (cmd == "msbt") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.MSBT = arg
		end
		print(yel.."Achievement Sounds: MSBT is "..AchSnd.StatColor(AchSnd_Settings.MSBT)..res)
		if ((not(IsAddOnLoaded("MikScrollingBattleText"))) and (AchSnd_Settings.MSBT == "on")) then
			print(yel.."Mik's Scrolling Battle Text is not loaded so text will not display in the MSBT frame"..res)
		end
		return
	end

	if (cmd == "popup") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.Popup = arg
		end
		print(yel.."Achievement Sounds: Popup is "..AchSnd.StatColor(AchSnd_Settings.Popup)..res)
		return
	end
	
	if (cmd == "timeout") then
		if ((arg >= 0) and (arg <= 60)) then
			AchSnd_Settings.Timeout = arg
		end
		print(yel.."Achievement Sounds: Timeout is "..AchSnd.StatColor(AchSnd_Settings.Timeout)..res)
		return
	end

	if (cmd == "random") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.Random = arg
		end
		print(yel.."Achievement Sounds: Random is "..AchSnd.StatColor(AchSnd_Settings.Random)..res)
		return
	end

	if (cmd == "defaultmsg") then
		if ( arg ) then
			if ( AchSnd.TextScanError(arg) ) then
				StaticPopup_Show("AchSnd.TextError")
				return
			end
			AchSnd_Settings.DefaultMsg = string.trim(string.sub( msg, #cmd +1))
		end
		print(yel.."Achievement Sounds: DefaultMsg is \""..grn..AchSnd_Settings.DefaultMsg..yel.."\""..res)
		return
	end

	if (cmd == "newmsgbox") then
		if ((arg == "on") or (arg == "off")) then
			AchSnd_Settings.NewMsgBox = arg
		end
		print(yel.."Achievement Sounds: NewMsgBox is "..AchSnd.StatColor(AchSnd_Settings.NewMsgBox)..res)
		return
	end

	if (cmd == "minalpha") then
		if ((arg >= 0) and (arg <= 1)) then
			AchSnd_Settings.MinAlpha = arg
		end
		print(yel.."Achievement Sounds: MinAlpha is "..AchSnd.StatColor(AchSnd_Settings.MinAlpha)..res)
	end
	
	if (cmd == "fadedelay") then
		if ((arg >= 0) and (arg <= AchSnd_Settings.FadeDelay)) then
			AchSnd_Settings.FadeDelay = arg
		end
		print(yel.."Achievement Sounds: FadeDelay is "..AchSnd.StatColor(AchSnd_Settings.FadeDelay)..res)
	end


	print(" ")
	print(yel.."  Achievement Sounds"..res)
	print(yel.."  Error: "..red..cmd..yel.." is not a valid command"..res)
	print(yel.."  Type: "..blu.."/achsnd "..yel.."for the list of commands and addon status"..res)
	return
end


